function CacheAssistant(gccode) {
	if(gccode.indexOf('GC') === 0) {
		this.geocode = gccode;
		this.guid = false;
	} else {
		this.geocode = false;
		this.guid = gccode;
	}
}

CacheAssistant.prototype.setup = function() {
	//this.controller.stageController.setWindowOrientation('free');
	if (this.geocode) {
		this.controller.get('cache-title').update(this.geocode);
	}
	this.controller.get('loading-spinner').show();
	/* setup widgets here */

	/* add event handlers to listen to events from widgets */
	this.cacheEncodeDecode = this.cacheEncodeDecode.bind(this);
	this.controller.listen("cache-hint-row", Mojo.Event.tap, this.cacheEncodeDecode);

	this.cacheOwnerClickHandle = this.cacheOwnerClickHandle.bind(this);
	this.controller.listen("cache-owner-row", Mojo.Event.tap, this.cacheOwnerClickHandle);

	this.cacheCompass = this.cacheCompass.bind(this);
	this.controller.listen("cache-location-row", Mojo.Event.tap, this.cacheCompass);

	this.cacheSpoilerImages = this.cacheSpoilerImages.bind(this);
	this.controller.listen("cache-spoilerimages-row", Mojo.Event.tap, this.cacheSpoilerImages);

	this.cacheDescription = this.cacheDescription.bind(this);
	this.controller.listen("cache-description-row", Mojo.Event.tap, this.cacheDescription);

	this.cacheWaypoints = this.cacheWaypoints.bind(this);
	this.controller.listen("cache-waypoints-row", Mojo.Event.tap, this.cacheWaypoints);

	this.cacheTrackables = this.cacheTrackables.bind(this);
	this.controller.listen("cache-trackables-row", Mojo.Event.tap, this.cacheTrackables);

	this.cacheAttributes = this.cacheAttributes.bind(this);
	this.controller.listen("cache-attributes-row", Mojo.Event.tap, this.cacheAttributes);
	
	this.controller.setupWidget('loading-spinner',
		this.spinnerLAttrs = {
			'spinnerSize': 'large'
		},
		this.spinnerModel = {
			'spinning': true
		}
	);

	if(this.geocode !== false) {
		if (Geocaching.db != null) {
			var item = [];
			Geocaching.db.transaction( 
				(function (transaction) {
					transaction.executeSql('select * from "caches" where "gccode"= ?;', [this.geocode],
						function(transaction, results) {
							try {
								var caches = results.rows.length;
								if(caches == 0) throw("Not in database");
								delete(caches);

								item = results.rows.item(0);

								cache[this.geocode] = unescape(item['json']).evalJSON();

								try {
									cache[this.geocode].userdata = unescape(item['userdata']).evalJSON();
								} catch(e) {
									cache[this.geocode].userdata = {};
								}
								
								try {
									if(item['found'] == 1)
										cache[this.geocode].found = true;
								} catch(e) {}

								try {
									if(item['favourite'] == 1)
										cache[this.geocode].favourite = true;
								} catch(e) {}

								cache[this.geocode].updated = item['updated'];

								if(typeof(cache[this.geocode].guid) == 'undefined')
									throw("loadit")

								this.showCacheDetail(this.geocode);
							} catch(e) {
								Mojo.Log.error(Object.toJSON(e));
								this.reloadCache();
							}
						}.bind(this)
					); 
				}).bind(this) 
			);
		} else {
			Geocaching.accounts['geocaching.com'].loadCache({
					'geocode': this.geocode
				},
				this.showCacheDetail.bind(this),
				function(message) {
					delete(cache[this.geocode]);
					this.controller.get('loading-spinner').hide();
					this.showPopup(null, $L("Problem"), message, function() { Mojo.Controller.stageController.popScene(); });
					return false;
				}.bind(this)
			);
		}
	} else {
		Mojo.Log.info('Loading by guid: '+this.guid);
		//  Load cache by guid
		if (Geocaching.db != null) {
			var item = [];
			Geocaching.db.transaction( 
				(function (transaction) {
					transaction.executeSql('select * from "caches" where "guid"= ?;', [this.guid],
						function(transaction, results) {
							try {
								var caches = results.rows.length;
								if(caches == 0) throw("Not in database");
								delete(caches);

								item = results.rows.item(0);

								this.geocode = item['gccode'];
								cache[this.geocode] = unescape(item['json']).evalJSON();

								try {
									cache[this.geocode].userdata = unescape(item['userdata']).evalJSON();
								} catch(e) {
									cache[this.geocode].userdata = {};
								}

								try {
									if(item['found'] == 1)
										cache[this.geocode].found = true;
								} catch(e) {}

								try {
									if(item['favourite'] == 1)
										cache[this.geocode].favourite = true;
								} catch(e) {}

								cache[this.geocode].updated = item['updated'];

								if(typeof(cache[this.geocode].guid) == 'undefined')
									throw("loadit")

								this.showCacheDetail(this.geocode);
							} catch(e) {
								Mojo.Log.error(Object.toJSON(e));
								this.reloadCache();
							}
						}.bind(this)
					); 
				}).bind(this) 
			);
		} else {
			Geocaching.accounts['geocaching.com'].loadCache({
					'guid': this.guid
				},
				this.showCacheDetail.bind(this),
				function(message) {
					delete(cache[this.geocode]);
					this.controller.get('loading-spinner').hide();
					this.showPopup(null, $L("Problem"), message, function() { Mojo.Controller.stageController.popScene(); });
					return false;
				}.bind(this)
			);
		}
		/* End of GUID loading */
	}

	/* Main Menu */
	this.appMenuModel = {
		'visible': true,
		'items': [
			Mojo.Menu.editItem,
			{'label': $L("Reload cache"), 'command': 'reloadcache' },
			{'label': $L("Find nearby caches"), 'command': 'findnearby' },
			{'label': $L("Find nearby caches of this type"), 'command': 'findnearbytype' }
		]
	};
	this.controller.setupWidget(Mojo.Menu.appMenu, {'omitDefaultItems': true}, this.appMenuModel);
	/* Command menu */
	this.commandMenuItem2 = {'label': 'Favourite', 'icon': 'make-vip', 'toggleCmd': 'nofavorite', 'items' :[
		{'label': 'Favourite', 'icon': 'make-vip', 'command': 'favourite'}
	]};
	this.controller.setupWidget(Mojo.Menu.commandMenu, {'menuClass': 'no-fade'},
		this.commandMenuModel = {
			'items':	[
				this.commandMenuItem1 = {items: [
					{'label': $L("More info"), 'icon': 'info', 'command': 'info'},
//					{label:'Users note', icon:'attach', command:'note', disabled: true},
					{'label': $L("Logs"), 'icon': 'search', 'command': 'logs'},
					{'label': $L("Compass"), 'iconPath': defaultnavigationIcons[Geocaching.settings['defaultnavigation']], 'command': 'compass'}
				]},
				this.commandMenuItem2,
				this.commandMenuItem3 = {'label': $L("Post log"), 'icon': 'send', 'command': 'log'} // Preparation for post log
			],
			'visible': false
		}
	);
}

CacheAssistant.prototype.activate = function(event) {
	if(event == 'posted') {
		this.reloadCache();
	}
}

CacheAssistant.prototype.deactivate = function(event) {
}

CacheAssistant.prototype.cleanup = function(event) {
	delete(cache[this.geocode]);
	Mojo.Event.stopListening(this.controller.get("cache-hint-row"), Mojo.Event.tap, this.cacheEncodeDecode);
	Mojo.Event.stopListening(this.controller.get("cache-owner-row"), Mojo.Event.tap, this.cacheOwnerClickHandle);
	Mojo.Event.stopListening(this.controller.get("cache-location-row"), Mojo.Event.tap, this.cacheCompass);
	Mojo.Event.stopListening(this.controller.get("cache-spoilerimages-row"), Mojo.Event.tap, this.cacheSpoilerImages);
	Mojo.Event.stopListening(this.controller.get("cache-description-row"), Mojo.Event.tap, this.cacheDescription);
	Mojo.Event.stopListening(this.controller.get("cache-waypoints-row"), Mojo.Event.tap, this.cacheWaypoints);
	Mojo.Event.stopListening(this.controller.get("cache-trackables-row"), Mojo.Event.tap, this.cacheTrackables);
	Mojo.Event.stopListening(this.controller.get("cache-attributes-row"), Mojo.Event.tap, this.cacheAttributes);
}

CacheAssistant.prototype.showCacheDetail = function(geocode) {
	this.geocode = geocode;

	if (this.geocode) {
		this.controller.get('cache-title').update(this.geocode);
	}
	
	this.controller.get('cache-icon').innerHTML = '<img class="gc-icon" src="images/'+ cacheTypes[cache[this.geocode].type] +'.gif" /> ';
	this.controller.get('cache-icon').className = 'icon img';
	this.controller.get('cache-name').update(cache[this.geocode].name);
	if(cache[this.geocode].found) {
		this.controller.get('cache-title').innerHTML += ' <img src="images/found.png" />';
	}
	if(cache[this.geocode].members) {
		this.controller.get('cache-title').innerHTML += ' <img src="images/members_small.gif" />';
	}
	if(cache[this.geocode].needsmaint) {
		this.controller.get('cache-title').innerHTML += ' <img src="images/needsmaint.gif" />';
	}

	if(cache[this.geocode].archived) {
		this.controller.get('cache-title').className += ' gc-archived';
		this.controller.get('cache-name').className += ' gc-archived';
		this.controller.get('cache-availability').update($L("Archived"));

	} else
	if(cache[this.geocode].disabled) {
		this.controller.get('cache-title').className += ' gc-disabled';
		this.controller.get('cache-name').className += ' gc-disabled';
		this.controller.get('cache-availability').update($L("Temporarily unavailable"));
	} else
	if(cache[this.geocode].members) {
		this.controller.get('cache-availability').update($L("For members only"));
	} else
	if(cache[this.geocode].needsmaint) {
		this.controller.get('cache-availability').update($L("Needs maintenance"));
	} else {
		this.controller.get('cache-availability').update($L("Available"));
	}

	try {
		if(cache[this.geocode].updated) {
			var updatedDate = new Date();
			updatedDate.setTime(cache[this.geocode].updated *1000);
			this.controller.get('cache-updated').update(Mojo.Format.formatDate(updatedDate, 'medium'));

			var tsNow = Math.round(new Date().getTime() / 1000)-(5*24*60*60);
			// Cache is outdated after 5 days
			if(cache[this.geocode].updated < tsNow) {
				this.controller.get('cache-title').innerHTML += ' <img src="images/outdated.png" />';
			}
		}
	} catch(e) { }

	this.controller.get('cache-type').update(cache[this.geocode].type);
	this.controller.get('cache-owner').update(cache[this.geocode].owner);
	this.controller.get('cache-hint').update(Geocaching.decodeText(cache[this.geocode].hint).replace("\n", '<br>'));
	this.controller.get('cache-size').src='images/'+ (cacheSizes[cache[this.geocode].size]?cacheSizes[cache[this.geocode].size]:'other') + '.gif';
	this.controller.get('cache-size-label').update($L(cache[this.geocode].size));
	this.controller.get('cache-terrain').src='images/stars'+ cache[this.geocode].terrain.replace('.', '_') + '.gif';
	this.controller.get('cache-terrain-label').update(cache[this.geocode].terrain);
	this.controller.get('cache-difficulty').src='images/stars'+ cache[this.geocode].difficulty.replace('.', '_') + '.gif';
	this.controller.get('cache-difficulty-label').update(cache[this.geocode].difficulty);
	this.controller.get('cache-latlon').update(cache[this.geocode].latitudeString+"<br>"+cache[this.geocode].longitudeString);
	this.controller.get('cache-location').update(cache[this.geocode].location);
	this.controller.get('cache-description').update(cache[this.geocode].shortdesc != "" ? cache[this.geocode].shortdesc : $L("Tap for full listing"));

	// Get my position to show map
	this.controller.serviceRequest('palm://com.palm.location', {
		'method': 'getCurrentPosition',
		'parameters': {
			'accuracy': 1,
			'responseTime': 1,
			'maximumAge': 60,
		},
		'onSuccess': this.actionMyPositionSuccess.bind(this),
		'onFailure': this.actionMyPositionSuccess.bind(this)
	});
	
	// Event date
	if(cache[this.geocode].date) {
		this.controller.get('cache-date').update(cache[this.geocode].date);
		this.controller.get('cache-date-row').show();
	}
	
	var siCount = cache[this.geocode].spoilerImages.length;
	if(siCount > 1) {
		this.controller.get('cache-spoilerimages').update($L("#{num} images").interpolate({'num': siCount}));
	} else
	if(siCount == 1) {
		this.controller.get('cache-spoilerimages').update($L("1 image"));
	} else {
		this.controller.get('cache-spoilerimages').update($L("No images"));
	}
	delete(siCount);

	var wpCount = cache[this.geocode].waypoints.length;
	try {
		wpCount += cache[this.geocode].userdata['waypoints'].length;
	} catch(e) {}
	if(wpCount > 1) {
		this.controller.get('cache-waypoints').update($L("#{num} waypoints").interpolate({'num': wpCount}) +' ');
	} else
	if(wpCount == 1) {
		this.controller.get('cache-waypoints').update($L("1 waypoint"));
	} else {
		this.controller.get('cache-waypoints').update($L("No waypoints"));
	}
	delete(wpCount);

	var trkCount = cache[this.geocode].trackables.length;
	if(trkCount > 1) {
		this.controller.get('cache-trackables').update($L("#{num} trackables").interpolate({'num': trkCount}) +' ');
	} else
	if(trkCount == 1) {
		this.controller.get('cache-trackables').update($L("1 trackable"));
	} else {
		this.controller.get('cache-trackables').update($L("No trackable"));
	}
	delete(trkCount);

	
	var atCount = cache[this.geocode].attrs.length;
	var attrs = new Array();
	if(atCount) {
		for(var i=0; i<atCount; i++) {
			attrs.push('<img src="images/attributes/'+ cache[this.geocode].attrs[i]['img'] +'.gif" />');
		}
		this.controller.get('cache-attributes').update(attrs.join(' '));
	} else {
		this.controller.get('cache-attributes').update($L("No attributes"));
	}
	
	if(cache[this.geocode].favourite) {

		this.commandMenuItem2 = {'label': 'Favourite', 'icon': 'make-vip', 'toggleCmd': 'favourite', 'items': [
			{'label': 'Favourite', 'icon': 'make-vip', 'command': 'favourite'}
		]};
		this.commandMenuModel['items'] = [
			this.commandMenuItem1,
			this.commandMenuItem2,
			this.commandMenuItem3
		]
		this.controller.modelChanged(this.commandMenuModel);
	}

	this.controller.get('loading-spinner').hide();
	this.controller.get('cache-detail').show();

	// Show command menu
	this.controller.setMenuVisible(Mojo.Menu.commandMenu, true);
}


CacheAssistant.prototype.showPopup = function(event, title, message, onChoose) {
	if(typeof(onChoose) != 'function') {
		onChoose = function() {}
	}
	this.controller.showAlertDialog({
		'onChoose': onChoose,
		'title': title,
		'message': message,
		'choices': [{'label': $L("Close"), 'value': 'close', 'type': 'negative'}]
	});
}

CacheAssistant.prototype.handleCommand = function(event) {
	if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case 'info':
				if(this.controller.get('cache-detail').className.indexOf('gc-basic') != -1) {
					this.controller.get('cache-detail').className = this.controller.get('cache-detail').className.replace(/gc-basic/g, '');
				} else {
					this.controller.get('cache-detail').className += ' gc-basic';
				}
			break;
			case 'logs':
				this.cacheLogs();
			break;
			case 'log':
				this.controller.popupSubmenu({
					'onChoose': function(choice) {
						switch(choice) {
							case 'website':
								this.controller.serviceRequest("palm://com.palm.applicationManager", {
									'method': "open",
									'parameters': {
										'id': 'com.palm.app.browser',
										'params': {
											'target': "http://www.geocaching.com/seek/log.aspx?ID="+ cache[this.geocode].cacheid
										}
									}
								});
							break;
							case 'postlog':
								this.controller.stageController.pushScene('postlog', this.geocode);
							break;
							case 'tweet':
								this.controller.stageController.pushScene('tweet', $L("I recommend #{code}. http://coord.info/#{code}").interpolate({'code': this.geocode}));
							break;
						}
					}.bind(this),
					'placeNear': event.originalEvent.target,
					'items': [
						{'label': $L("Tweet about cache"), 'disabled': (Geocaching.logins['twitter']['oauth_token'] == null), 'command':'tweet'},
						{'label': $L("Post log"), 'command': 'postlog'},
//						{'label': $L("Post log on Geocaching.com"), 'command': 'website'}
					]
				});
			break;
			case 'findnearby':
				if(cache[this.geocode].latitude != 0 && cache[this.geocode].longitude != 0) {
					Mojo.Controller.stageController.pushScene('list', 'coords', {
						'lat': cache[this.geocode].latitude,
						'lon': cache[this.geocode].longitude,
						'tx': cacheIDs['all']
					});
				}
			break;
			case 'findnearbytype':
				if(cache[this.geocode].latitude != 0 && cache[this.geocode].longitude != 0) {
					Mojo.Controller.stageController.pushScene('list', 'coords', {
						lat: cache[this.geocode].latitude,
						lon: cache[this.geocode].longitude,
						tx: cacheIDs[cacheTypes[cache[this.geocode].type]]
					});
				}
			break;
			case 'reloadcache':
				this.reloadCache();
			break;
			case 'compass':
				this.cacheCompass(event);
			break;
			case 'favourite':
				var favourite;
				if(cache[this.geocode].favourite) {
					favourite = 0;
					cache[this.geocode].favourite = false;
				} else {
					favourite = 1;
					cache[this.geocode].favourite = true;
				}

				Geocaching.db.transaction( 
					(function (transaction) {
						transaction.executeSql('UPDATE "caches" SET "favourite"='+ favourite +' WHERE "gccode"="'+ escape(this.geocode) +'";', []);
					}).bind(this)
				);
			break;
			default:
			break;
		}
	}
}

CacheAssistant.prototype.cacheEncodeDecode = function(event) {
	this.controller.get('cache-hint').innerHTML = Geocaching.decodeText(this.controller.get('cache-hint').innerHTML.replace("<br>", "\n")).replace("\n", "<br>");
}

CacheAssistant.prototype.cacheOwnerClickHandle = function(event) {
	this.controller.popupSubmenu({
		'onChoose': function(command) {
			switch(command) {
				case 'found':
					Mojo.Controller.stageController.pushScene('list', 'username', {
						'username': cache[this.geocode].owner,
						'tx': cacheIDs['all']
					});
					break;
				case 'owner':
					Mojo.Controller.stageController.pushScene('list', 'owner', {
						'username': cache[this.geocode].owner,
						'tx': cacheIDs['all']
					});
					break
			}
		}.bind(this),
		'placeNear': event.target,
		'items': [
			{'label': $L('Hidden by this user'), 'command': 'owner'},
			{'label': $L('Found by this user'), 'command': 'found'}
		]
	});
}

CacheAssistant.prototype.cacheDescription = function(event) {
	Mojo.Controller.stageController.pushScene('description', this.geocode);
}

CacheAssistant.prototype.cacheSpoilerImages = function(event) {
	if(cache[this.geocode].spoilerImages.length > 0) {
		Mojo.Controller.stageController.pushScene('spoilerimages', this.geocode);
	}
}

CacheAssistant.prototype.cacheLogs = function(event) {
	Mojo.Controller.stageController.pushScene('cachelogs', this.geocode);
}

CacheAssistant.prototype.cacheCompass = function(event) {
	if(Geocaching.settings['defaultnavigation'] == 'googlemaps') {
		var url = "http://maps.google.com/?q="+ escape(cache[this.geocode].latitude.toFixed(5) +","+ cache[this.geocode].longitude.toFixed(5)) +"("+ escape(this.geocode) +")@" + cache[this.geocode].latitude +","+ cache[this.geocode].longitude +"&t=h&z=17";
		this.controller.serviceRequest('palm://com.palm.applicationManager', {
			'method': 'open',
			'parameters': {'target': url}
		});
		return true;
	}

	var waypoints = [];
	waypoints.push({
		'title': this.geocode,
		'latitude': cache[this.geocode].latitude,
		'longitude': cache[this.geocode].longitude,
		'wptType': 'cache',
		'type': cache[this.geocode].type
	});
	
	if(cache[this.geocode].waypoints.length > 0) {
		for(var z in cache[this.geocode].waypoints) {
			var wp = cache[this.geocode].waypoints[z];
			if(typeof(wp['latitude'])!='undefined' && typeof(wp['longitude'])!='undefined') {
				waypoints.push({
					'title': $L("Waypoint #{name}").interpolate({'name': wp['name']}),
					'latitude': wp['latitude'],
					'longitude': wp['longitude'],
					'wptType': 'waypoint',
					'type': wp['type']
				});
			}
		}
	}

	// Add user waypoints
	try {
		var userWpts = cache[this.geocode].userdata['waypoints'];
		var userWptsLen = userWpts.length;
		if(userWptsLen > 0) {
			for(z=0; z<userWptsLen; z++) {
				var wp = cache[this.geocode].userdata['waypoints'][z];
				if(typeof(wp['latitude'])!='undefined' && typeof(wp['longitude'])!='undefined') {
					waypoints.push({
						'title': $L("Waypoint #{name}").interpolate({'name': wp['name']}),
						'latitude': wp['latitude'],
						'longitude': wp['longitude'],
						'wptType': 'waypoint',
						'type': wp['type']
					});
				}
			}
		}
	} catch(e) {
		Mojo.Log.error(Object.toJSON(e));
	}

	if(Geocaching.settings['defaultnavigation'] == 'mappingtool') {
		var params = Geocaching.format4Maptool(waypoints);
		this.controller.serviceRequest('palm://com.palm.applicationManager', {
			'method': 'launch',
			'parameters': {
				'id': 'de.metaviewsoft.maptoolpro',
				'params': Object.toJSON(params)
			},
			'onFailure': function(text, value) {
				this.controller.serviceRequest('palm://com.palm.applicationManager', {
					'method': 'launch',
					'parameters': {
						'id': 'de.metaviewsoft.maptool',
						'params': Object.toJSON(params)
					},
					'onFailure': function(text, value) {
						this.controller.showAlertDialog({
							'onChoose': function(value) {},
							'title': $L("Execution failure"),
							'message': $L({'value': "This feature require external application 'Mapping Tool'. It can be downloaded from PreCentral.net Homebrew Directory.", 'key': 'mappingtool_failure'}),
							'choices': [{'label': $L("Close"), 'value':'close', 'type':'primary'} ]
						});
					}.bind(this)
				});
			}.bind(this)
		});
		return true;
	}

	if(Geocaching.settings['compassInNewCard']) {
		var geocode = this.geocode;
		var appController = Mojo.Controller.getAppController();
		var f = function(stageController){
			stageController.pushScene(
				{
					'name': 'compass',
					'disableSceneScroller': true
				}, {
					'title': geocode,
					'latitude': cache[geocode].latitude,
					'longitude': cache[geocode].longitude,
					'waypoints': waypoints,
					'geocode': geocode
				}
			);
		};
		appController.createStageWithCallback({
			'name': 'compass'+this.geocode,
			'lightweight': true
		}, f, 'card');
	} else {
		Mojo.Controller.stageController.pushScene(
			{
				'name': 'compass',
				'disableSceneScroller': true
			}, {
				'title': this.geocode,
				'latitude': cache[this.geocode].latitude,
				'longitude': cache[this.geocode].longitude,
				'waypoints': waypoints,
				'geocode': this.geocode
			}
		);
	}
}

CacheAssistant.prototype.cacheWaypoints = function(event) {
	Mojo.Controller.stageController.pushScene('waypoints', this.geocode);
}

CacheAssistant.prototype.cacheTrackables = function(event) {
	if(cache[this.geocode].trackables.length > 0) {
		Mojo.Controller.stageController.pushScene('trackables', 'cache', {'gccode': this.geocode});
	}
}

CacheAssistant.prototype.cacheAttributes = function(event) {
	if(cache[this.geocode].attrs.length > 0) {
		Mojo.Controller.stageController.pushScene('attributes', this.geocode);
	}
}

CacheAssistant.prototype.reloadCache = function() {
	if (this.geocode) {
		this.controller.get('cache-title').update(this.geocode);
	}

	this.controller.get('cache-detail').hide();
	this.controller.get('loading-spinner').show();
	
	var item;
	try {
		item = {
			'found': cache[this.geocode].found
		};
	} catch(e) {
		item = {
			'found': false
		};
	}
	try {
		item = {
			'userdata': cache[this.geocode].userdata
		};
	} catch(e) {
		item = {
			'userdata': {}
		};
	}

	if(this.geocode !== false) {
		Geocaching.accounts['geocaching.com'].loadCache({
				'geocode': this.geocode
			},
			function() {
				try {
					if(item['found'] == 1)
						cache[this.geocode].found = true;
				} catch(e) {}
				cache[this.geocode].userdata = item['userdata'];

				var ts = Math.round(new Date().getTime() / 1000);
				cache[this.geocode].updated = ts;
				
				this.guid = cache[this.geocode].guid;

				var query = 'INSERT INTO "caches"("gccode", "guid", "updated", "found", "latitude", "longitude", "json") VALUES ("'+
					escape(this.geocode) + '", "' + 
					escape(this.guid) + '", ' + 
					escape(ts) + ', ' +
					escape(cache[this.geocode].found?1:0) + ', ' +
					escape(cache[this.geocode].latitude) + ', ' +
					escape(cache[this.geocode].longitude) + ', "' +  
					escape(Object.toJSON(cache[this.geocode])) +'"); GO;';

				Geocaching.db.transaction( 
					(function (transaction) { 
						transaction.executeSql(query, [], 
							function() {},
							function(transaction, error) {
								if(error['code'] == 1) {
									transaction.executeSql('UPDATE "caches" SET '+
										'"guid"="'+ escape(cache[this.geocode].guid) +'", '+
										'"json"="'+ escape(Object.toJSON(cache[this.geocode])) +'", '+
										'"updated"="'+ escape(ts) +'", '+
										'"found"="'+ escape(cache[this.geocode].found?1:0) +'", '+
										'"latitude"='+ escape(cache[this.geocode].latitude) +', '+
										'"longitude"='+ escape(cache[this.geocode].longitude) +' '+
										' WHERE "gccode"="'+ escape(this.geocode) +'"; GO; ', []);
								}
							}.bind(this)
						);
					}).bind(this) 
				); 

				this.showCacheDetail(this.geocode);
			}.bind(this),
			function(message) {
				delete(cache[this.geocode]);
				this.controller.get('loading-spinner').hide();
				this.showPopup(null, $L("Problem"), message, function() { Mojo.Controller.stageController.popScene(); });
				return false;
			}.bind(this)
		);
	} else {
		// Load by GUID
		Geocaching.accounts['geocaching.com'].loadCache({
				'guid': this.guid
			},
			function(geocode) {
				this.geocode = geocode;
				try {
					if(item['found'] == 1)
						cache[this.geocode].found = true;
				} catch(e) {}

				var ts = Math.round(new Date().getTime() / 1000);
				cache[this.geocode].updated = ts;

				var query = 'INSERT INTO "caches"("gccode", "guid", "updated", "found", "latitude", "longitude", "json") VALUES ("'+
					escape(this.geocode) + '", "' + 
					escape(this.guid) + '", ' + 
					escape(ts) + ', ' +
					escape(cache[this.geocode].found?1:0) + ', ' +
					escape(cache[this.geocode].latitude) + ', ' +
					escape(cache[this.geocode].longitude) + ', "' +  
					escape(Object.toJSON(cache[this.geocode])) +'"); GO;';

				Geocaching.db.transaction( 
					(function (transaction) { 
						transaction.executeSql(query, [], 
							function() {},
							function(transaction, error) {
								if(error['code'] == 1) {
									transaction.executeSql('UPDATE "caches" SET '+
										'"guid"="'+ escape(cache[this.geocode].guid) +'", '+
										'"json"="'+ escape(Object.toJSON(cache[this.geocode])) +'", '+
										'"updated"="'+ escape(ts) +'", '+
										'"found"="'+ escape(cache[this.geocode].found?1:0) +'", '+
										'"latitude"='+ escape(cache[this.geocode].latitude) +', '+
										'"longitude"='+ escape(cache[this.geocode].longitude) +' '+
										' WHERE "gccode"="'+ escape(this.geocode) +'"; GO; ', []);
								}
							}.bind(this)
						);
					}).bind(this) 
				); 

				this.showCacheDetail(this.geocode);
			}.bind(this),
			function(message) {
				delete(cache[this.geocode]);
				this.controller.get('loading-spinner').hide();
				this.showPopup(null, $L("Problem"), message, function() { Mojo.Controller.stageController.popScene(); });
				return false;
			}.bind(this)
		);
	}
}

CacheAssistant.prototype.actionMyPositionSuccess = function(event) {
	var accuracy = event.horizAccuracy;
	if(!accuracy) {
		this.actionMyPositionFailed(event);
		return false;
	}
	
	var latitude = event.latitude.toFixed(5);
	var longitude = event.longitude.toFixed(5);

	// Share GPS location
	if(Geocaching.settings['go4cache']) {
		Geocaching.accounts['go4cache'].sendLocation(latitude, longitude, this.geocode);
	}
	
	var distance = Geocaching.getDistance(latitude, longitude, cache[this.geocode].latitude, cache[this.geocode].longitude);	
	var markerSize = 'tiny';
	if(distance > 5) {
		markerSize = 'small';
	}
	var target = '';
	var url = 'http://maps.google.com/maps/api/staticmap?size=320x120&sensor=false&mobile=true&format=png';
	
	if(distance < 5) {
		if(cache[this.geocode].waypoints.length > 0) {
			for(var z in cache[this.geocode].waypoints) {
				var wp = cache[this.geocode].waypoints[z];
				if(typeof(wp['latitude'])!='undefined' && typeof(wp['longitude'])!='undefined') {
					target = 'icon:http://www.geocaching.com/images/wpttypes/sm/'+ wp['type'] +'.jpg|'+ wp['latitude'].toFixed(5) +','+ wp['longitude'].toFixed(5)
					url += '&markers='+encodeURIComponent(target);
				}
			}
		}
		try {
			if(typeof(cache[this.geocode].userdata['waypoints']) != 'undefined') {
				var userWpts = cache[this.geocode].userdata['waypoints'];
				var userWptsLen = userWpts.length;
				if(userWptsLen > 0) {
					for(z=0; z<userWptsLen; z++) {
						var wp = cache[this.geocode].userdata['waypoints'][z];
						if(typeof(wp['latitude'])!='undefined' && typeof(wp['longitude'])!='undefined') {
							target = 'icon:http://www.geocaching.com/images/wpttypes/sm/waypoint.jpg|'+ wp['latitude'].toFixed(5) +','+ wp['longitude'].toFixed(5)
							url += '&markers='+encodeURIComponent(target);
						}
					}
				}
			}
		} catch(e) {
			Mojo.Log.error('Exception raised in adding user waypoints to map: %j', e);
		}
	}

	// Finally, add position and target
	url += '&markers='+ encodeURIComponent('color:blue|size:'+ markerSize +'|'+ latitude +','+ longitude) + '&markers='+ encodeURIComponent('icon:http://www.geocaching.com/images/wpttypes/sm/'+ cacheTypesIDs[cache[this.geocode].type] +'.gif|'+ cache[this.geocode].latitude.toFixed(5) +','+ cache[this.geocode].longitude.toFixed(5));

	Mojo.Log.info('Minimap with user position url: %s', url);

	this.controller.get('cachemap').update('<img src="'+ url +'" />');
};

CacheAssistant.prototype.actionMyPositionFailed = function(event) {
	
	// Share GPS location
	if(Geocaching.settings['go4cache']) {
		Geocaching.accounts['go4cache'].sendLocation(cache[this.geocode].latitude, cache[this.geocode].longitude, 'discovering');
	}	
	
	var icon = 'http://www.geocaching.com/images/wpttypes/sm/'+ cacheTypesIDs[cache[this.geocode].type] +'.gif';
	var url = 'http://maps.google.com/maps/api/staticmap?size=320x120&sensor=false&mobile=true&format=png';
	
	if(cache[this.geocode].waypoints.length > 0) {
		for(var z in cache[this.geocode].waypoints) {
			var wp = cache[this.geocode].waypoints[z];
			if(typeof(wp['latitude'])!='undefined' && typeof(wp['longitude'])!='undefined') {
				target = 'icon:http://www.geocaching.com/images/wpttypes/sm/'+ wp['type'] +'.jpg|'+ wp['latitude'].toFixed(5) +','+ wp['longitude'].toFixed(5)
				url += '&markers='+encodeURIComponent(target);
			}
		}
	}
	try {
		if(typeof(cache[this.geocode].userdata['waypoints']) != 'undefined') {
			var userWpts = cache[this.geocode].userdata['waypoints'];
			var userWptsLen = userWpts.length;
			if(userWptsLen > 0) {
				for(z=0; z<userWptsLen; z++) {
					var wp = cache[this.geocode].userdata['waypoints'][z];
					if(typeof(wp['latitude'])!='undefined' && typeof(wp['longitude'])!='undefined') {
						target = 'icon:http://www.geocaching.com/images/wpttypes/sm/waypoint.jpg|'+ wp['latitude'].toFixed(5) +','+ wp['longitude'].toFixed(5)
						url += '&markers='+encodeURIComponent(target);
					}
				}
			}
		}
	} catch(e) {
		Mojo.Log.error('Exception raised in adding user waypoints to map: %j', e);
	}	
	
	// Finally, add target
	url += '&markers='+ encodeURIComponent('icon:'+icon+'|'+cache[this.geocode].latitude.toFixed(5)+','+cache[this.geocode].longitude.toFixed(5));

	Mojo.Log.info('Minimap url: %s', url);
	
	this.controller.get('cachemap').update('<img src="'+ url +'" />');
}