GeocachingCom  = function() {
}

GeocachingCom.prototype.doLogin = function(username, password, success, failure)
{
	/* Load login page to check inputs */
	var url = "https://www.geocaching.com/login/default.aspx?RESET=Y";
	var checkAjax = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			var reply = r.responseText;
			var viewstate = reply.match(/id="__VIEWSTATE"\s+value="([^"]+)"/)[1]
			var posturl = 'https://www.geocaching.com/login/default.aspx';
			var postdata = {
				'__EVENTTARGET': "",
				'__EVENTARGUMENT': "",
				'__VIEWSTATE': viewstate,
				'ctl00$SiteContent$tbUsername': username,
				'ctl00$SiteContent$tbPassword': password,
				'ctl00$SiteContent$cbRememberMe': "on",
				'ctl00$SiteContent$btnSignIn': "Login",
				/*
				'ctl00$ContentBody$myUsername': username,
				'ctl00$ContentBody$myPassword': password,
				'ctl00$ContentBody$cookie': "on",
				'ctl00$ContentBody$Button1': "Login",
				*/
			};

			try {
				var eventvalidation = reply.match(/id="__EVENTVALIDATION"\s+value="([^"]+)"/)[1]
				postdata['__EVENTVALIDATION'] = eventvalidation;
			} catch(e) { /* None */ }
			
			var loginAjax = new Ajax.Request(posturl, {
				'method': 'post',
				'parameters': postdata,
				'contentType': 'application/x-www-form-urlencoded',
				'onSuccess': function(r){
					var reply = r.responseText;
					if(!this.checkLogin(reply)) {
						failure($L("Incorrect username or password!"));
						return false;
					}

					// Switch to English
					var viewstate = reply.match(/id="__VIEWSTATE"\s+value="(.+?)"/)[1]
					var posturl = 'https://www.geocaching.com/login/default.aspx';
					var parameters = {
						'__EVENTTARGET': 'ctl00$uxLocaleList$uxLocaleList$ctl01$uxLocaleItem',
						'__EVENTARGUMENT': '',
						'__VIEWSTATE' : viewstate
					};
					var englishAjax = new Ajax.Request(posturl, {
						'method': 'post',
						'parameters': parameters,
						'contentType': 'application/x-www-form-urlencoded',
					});

					success();
					return true;
				}.bind(this)
			});
		}.bind(this),
		onFailure: function(r){
			failure($L("Error occured on loging."));
		}
	});
}

GeocachingCom.prototype.getUID = function(success)
{
	Mojo.Log.error('Getting UID');
	var url = "http://www.geocaching.com/my/default.aspx";
	var userpageAjax = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			var reply = r.responseText;
			var uid = reply.match(/(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/profile\/\?guid=([a-z0-9\-]+)/i)[3]
			success(uid);
		}.bind(this),
		'onFailure': function(r){
			Mojo.Log.error('Fail!');
		}
	});
};

GeocachingCom.prototype.checkLogin = function(page)
{
Mojo.Log.error(page.substr(0000,1000));
Mojo.Log.error(page.substr(1000,1000));
Mojo.Log.error(page.substr(2000,1000));
Mojo.Log.error(page.substr(3000,1000));
Mojo.Log.error(page.substr(4000,1000));
Mojo.Log.error(page.substr(5000,1000));
Mojo.Log.error(page.substr(6000,1000));
	Mojo.Log.error("checkLogin:");
	if(-1 != page.search('<a href="http://www.geocaching.com/my/default.aspx"')) {
	Mojo.Log.error("true");
		return true;
	}
	Mojo.Log.error("false");
	return false;
}

GeocachingCom.prototype.parseSearch = function(url, reply)
{
	var viewstate = new Array();
	var viewstate0, viewstate1, viewstate2, viewstate3, eventvalidation0;
	
	try {
		eventvalidation0 = reply.match(/id="__EVENTVALIDATION" value="([^"]+)"/)[1]
		viewstate.push(eventvalidation0);
	} catch(e) {
		viewstate.push(false);
	}
	
	try {
		viewstate0 = reply.match(/id="__VIEWSTATE" value="([^"]+)"/)[1]
		viewstate.push(viewstate0);
	} catch(e) { }

	try {
		viewstate1 = reply.match(/id="__VIEWSTATE1" value="([^"]+)"/)[1]
		viewstate.push(viewstate1);
	} catch(e) { }
	
	try {
		viewstate2 = reply.match(/id="__VIEWSTATE2" value="([^"]+)"/)[1]
		viewstate.push(viewstate2);
	} catch(e) { }

	try {
		viewstate3 = reply.match(/id="__VIEWSTATE3" value="([^"]+)"/)[1]
		viewstate.push(viewstate3);
	} catch(e) { }


	var startPos = reply.indexOf('<table id="ctl00_ContentBody_dlResults"');
	if(startPos == -1)
		return false;

	
	var r = reply.substr(startPos); // Cut on <table
	
	startPos = r.indexOf('>');
	var endPos = r.indexOf('ctl00_ContentBody_UnitTxt');
	if(startPos == -1 || endPos == -1)
		return false;

	r = r.substr(startPos+1, endPos-startPos+1); // Cut between <table> and </table>

	var rows = r.split("</tr><tr>");
	var rows_count = rows.length;
	var list = new Array();

	for(var z=1; z<rows_count; z++) { try {
		var row = rows[z];
		var listRow = {}
		var tmp;
		// Check for Cache type presence
		if(row.indexOf('images/wpttypes/sm') == -1) {
			continue;
		}

		// Cache type
		listRow['type'] = row.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/sm\/[^.]+\.gif" alt="([^"]+)" title="([^"]+)" \/><\/a>/i)[3]
		
		// Direction and distance (not in all lists)
		try {
			tmp = row.match(/>([SWEN]+)<br[^>]*>([0-9\.a-z]+)/i);
			listRow['direction'] = tmp[1];
			listRow['distance'] = tmp[2];
		} catch(e) {
			// Possibly is Here or distance is not present
		}

	/**
	* Disabled in 2010-12-22 update
	*/

		// Cache attributes
		//try {
		//	listRow['attribs'] = row.match(/\(([0-9.]+\/[0-9.]+)\)/)[1]
		//} catch(e) { }

		// Cache size
		//try {
		//	listRow['size'] = row.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/icons\/container\/[a-z_]+.gif" alt="Size: ([^"]+)"/i)[3]
		//} catch(e) {
		//	listRow['size'] = 'none';
		//}

		try {
			listRow['gsattr'] = row.match(/\/ImgGen\/seek\/CacheInfo\.ashx\?v=([a-z0-9]+)/i)[1]
		} catch(e) {	}

		// GUID and disabled
		try {
			tmp = row.match(/guid=([a-z0-9\-]+)" class="lnk([^"]*)"><span>([^<]*)<\/span>/i);
			listRow['guid'] = tmp[1];
			listRow['name'] = tmp[3];
			if(tmp[2].indexOf("Warning") != -1 && tmp[2].indexOf("Strike") != -1) {
				listRow['archived'] = true;
			} else {
				listRow['archived'] = false;
			}
			if(tmp[2].indexOf("Strike") != -1) {
				listRow['disabled'] = true;
			} else {
				listRow['disabled'] = false;
			}
			if(tmp[2].indexOf("OldWarning") != -1 && tmp[2].indexOf("Strike") != -1) {
				listRow['archived'] = true;
			} else {
				listRow['archived'] = false;
			}

		} catch(e) {
			Mojo.Log.error(Object.toJSON(e));
		}

		if(row.indexOf('images/small_profile.gif') != -1)
			listRow['members'] = true;
		else
			listRow['members'] = false;

		listRow['gccode'] = row.match(/\((GC[a-z0-9]+)\)/i)[1]
		
		// Found it flag!
		if(row.indexOf('images/silk/emoticon_smile.png') != -1) {
			row = row.replace('images/silk/emoticon_smile.png', '');
			listRow['found'] = true;
		} else { 
			listRow['found'] = false;
		}

		// Trackables
		listRow['trackables'] = new Array();
		try {
			tmp = row.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/([^.]+)\.gif"/ig);
			// First one is cache type
			if(tmp.length>1) {
				var len = tmp.length, trkTmp;
				for(var i=1; i<len; i++) {
					trkTmp = tmp[i].match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/([^.]+)\.gif"/i);
					listRow['trackables'].push(trkTmp[2]);
				}
				delete(trkTmp); delete(len);
			}
		} catch(e) {
			Mojo.Log.error(Object.toJSON(e));
		}

		try {
			listRow['cacheid'] = row.match(/name="CID" value="(\d+)"/i)[1]
		} catch(e) {
		}
		
		list.push(listRow);
	} catch(e) {
		Mojo.Log.error(Object.toJSON(e));
		if(Geocaching.sendReport('parseSearch_'+url, reply, e)) {
			break;
		}
	} };

	if(list.length == 0)
		return false;

	var searchResult = {
		'url': url,
		'viewstate': viewstate,
		'cacheList': list
	}

	return searchResult;
}

GeocachingCom.prototype.urlParams = function() {
	var url = "";
	if(Geocaching.settings['hidemysearch']) {
		url += '&f=1';
	}
	return url;
}

GeocachingCom.prototype.downloadLoc = function(cids, success)
{
	var url = 'http://www.geocaching.com/seek/nearest.aspx?';
	var ajaxId = 'loc-'+ Math.round(new Date().getTime());

	var parameters = new Array();
	var len = cids.length;
	for(var z=0;z<len; z++) {
		parameters.push('CID='+cids[z]);
	}
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'post',
		'parameters': parameters.join('&')+'&Download=Download+Waypoints',
		'contentType': 'application/x-www-form-urlencoded',
		'onSuccess': function(r){
			var reply = r.responseText;
			var waypoints = {};
			var responseXML = (new DOMParser()).parseFromString(reply, "text/xml");
			var wpts = responseXML.getElementsByTagName('waypoint');
			var wptsLen = wpts.length, wpt, _gccode, _latitude, _longitude;
			for(var z=0; z<wptsLen; z++) {
				try {
					wpt = wpts[z];
					_latitude = wpt.getElementsByTagName('coord')[0].getAttribute('lat');
					_longitude = wpt.getElementsByTagName('coord')[0].getAttribute('lon');
					_gccode = wpt.getElementsByTagName('name')[0].getAttribute('id');
					waypoints[_gccode] = {
						'lat': _latitude,
						'lon': _longitude
					}
				} catch(e) {
					Mojo.Log.error('Error in LOC file parsing', e);
				}
			}
			success(waypoints);
		}.bind(this)
	});
}

GeocachingCom.prototype.searchByUrlNextPage = function(params, success, failure)
{
	var url = params['url'];
	var viewstate = params['viewstate'];
	var viewstate_len = viewstate.length;
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	var parameters = {
		'__VIEWSTATE' : viewstate[1],
		'__EVENTTARGET': 'ctl00$ContentBody$pgrBottom$ctl08',
		'__EVENTARGUMENT': ''
	}
	
	if(viewstate[0] !== false) {
		parameters['__EVENTVALIDATION'] = viewstate[0];
	}
	
	if(viewstate_len > 2) {
			for(var i=2; i<viewstate_len; i++) {
				parameters['__VIEWSTATE'+(i-1)] = viewstate[i]
			}
			parameters['__VIEWSTATEFIELDCOUNT'] = viewstate_len-1;
	}

var ajaxId = 'nextpage-'+ viewstate[1].substr(0,16) +'-'+ Math.round(new Date().getTime());
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'post',
		'parameters': parameters,
		'contentType': 'application/x-www-form-urlencoded',
		'onSuccess': function(r){
			var reply = r.responseText;
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.searchByUrlNextPage(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}
			var list = this.parseSearch(url, reply);
			if(list == false) {
				failure($L("No more caches found."));
			} else {
				success(list);
			}
		}.bind(this),
		'onFailure': function(r){
			Mojo.Log.error(Object.toJSON(r));
			failure($L("Error occured on fetching list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({messageText: $L("Getting cache list failed, retrying ...")}, '', 'cachelist');
				params['retry']++;
				this.searchByUrlNextPage(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
}

GeocachingCom.prototype.searchByKeyword = function(params, success, failure)
{
	var keyword = params['keyword'];
	var cachetype = params['cachetype'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	var url = "http://www.geocaching.com/seek/nearest.aspx?tx="+ encodeURIComponent(cachetype) +"&key="+ encodeURIComponent(keyword) + this.urlParams();
	var ajaxId = 'keyword-'+ keyword +'-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText;
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.searchByKeyword(params, success, failure)
					}.bind(this),
					failure
				);
				return false;
			}
			var list = this.parseSearch(url, reply);
			if(list == false) {
				failure($L("No caches found."));
			} else {
				success(list);
			}
		}.bind(this),
		'onFailure': function(r){
			Mojo.Log.error(Object.toJSON(r));
			failure($L("Error occured on fetching list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({messageText: $L("Getting cache list failed, retrying ...")}, '', 'cachelist');
				params['retry']++;
				this.searchByKeyword(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
}

GeocachingCom.prototype.searchByCoords = function(params, success, failure)
{
	var latitude = params['latitude'];
	var longitude = params['longitude'];
	var cachetype = params['cachetype'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	// http://www.geocaching.com/seek/nearest.aspx?lat_ns=1&lat_h=52&lat_mmss=34534&long_ew=-1&long_h=13&long_mmss=23423&dist=100&submit8=Search
	var url = "http://www.geocaching.com/seek/nearest.aspx";
	//var url = "http://www.geocaching.com/seek/nearest.aspx?tx="+ encodeURIComponent(cachetype) +"&lat="+ encodeURIComponent(latitude) +"&lng="+ encodeURIComponent(longitude) + this.urlParams();
	var ajaxId = 'coords-'+ latitude +'-'+ longitude +'-'+ Math.round(new Date().getTime());

	var postdata = {
		'__EVENTTARGET': "",
		'__EVENTARGUMENT': "",
		'__VIEWSTATE': viewstate,
		'ctl00$ContentBody$uxTaxonomies': "9a79e6ce-3344-409c-bbe9-496530baf758",
		'ctl00$ContentBody$LocationPanel1$ddSearchType': "WPT",
		'ctl00$ContentBody$LocationPanel1$LatLong': "4",
		'ctl00$ContentBody$LocationPanel1$LatLong:_selectNorthSouth': "1",
		'ctl00$ContentBody$LocationPanel1$LatLong$_inputLatDegs': latitude,
		'ctl00$ContentBody$LocationPanel1$LatLong:_selectEastWest': "1",
		'ctl00$ContentBody$LocationPanel1$LatLong$_inputLongDegs': longitude,
		'ctl00$ContentBody$LocationPanel1$LatLong:_currentLatLongFormat': "1",
		'ctl00$ContentBody$LocationPanel1$btnLocale': "Search for Geocaches"
		/*
		'ctl00$ContentBody$myUsername': username,
		'ctl00$ContentBody$myPassword': password,
		'ctl00$ContentBody$cookie': "on",
		'ctl00$ContentBody$Button1': "Login",
		*/
	};

	try {
		var eventvalidation = reply.match(/id="__EVENTVALIDATION"\s+value="([^"]+)"/)[1]
		postdata['__EVENTVALIDATION'] = eventvalidation;
	} catch(e) { /* None */ }

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'post',
		'parameters': postdata,
		'contentType': 'application/x-www-form-urlencoded',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);
			var reply = r.responseText;
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.searchByCoords(params, success, failure)
					}.bind(this),
					failure
				);
				return false;
			}
			var list = this.parseSearch(url, reply);
			if(list == false) {
				failure($L("No caches found."));
			} else {
				success(list);
			}
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({messageText: $L("Getting cache list failed, retrying ...")}, '', 'cachelist');
				params['retry']++;
				this.searchByCoords(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
}

GeocachingCom.prototype.searchByUsername = function( params, success, failure)
{
	var username = params['username'];
	var cachetype = params['cachetype'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	var url = "http://www.geocaching.com/seek/nearest.aspx?tx="+ encodeURIComponent(cachetype) +"&ul="+ encodeURIComponent(username) + this.urlParams();
	var ajaxId = 'username-'+ username +'-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText;
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.searchByUsername(params, success, failure)
					}.bind(this),
					failure
				);
				return false;
			}
			var list = this.parseSearch(url, reply);
			if(list == false) {
				failure($L("No caches found."));
			} else {
				success(list);
			}
		}.bind(this),
		onFailure: function(r){
			failure($L("Error occured on fetching list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({messageText: $L("Getting cache list failed, retrying ...")}, '', 'cachelist');
				params['retry']++;
				this.searchByUsername(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
}

GeocachingCom.prototype.searchByOwner = function(params, success, failure)
{
	var username = params['username'];
	var cachetype = params['cachetype'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	var url = "http://www.geocaching.com/seek/nearest.aspx?tx="+ encodeURIComponent(cachetype) +"&u="+ encodeURIComponent(username) + this.urlParams();
	var ajaxId = 'owner-'+ username +'-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText;
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'],
					function() {
						this.searchByOwner(params, success, failure)
					}.bind(this),
					failure
				);
				return false;
			}
			var list = this.parseSearch(url, reply);
			if(list == false) {
				failure($L("No caches found."));
			} else {
				success(list);
			}
		}.bind(this),
		onFailure: function(r){
			failure($L("Error occured on fetching list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({messageText: $L("Getting cache list failed, retrying ...")}, '', 'cachelist');
				params['retry']++;
				this.searchByOwner(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
}

GeocachingCom.prototype.loadCache = function(params, success, failure)
{
	var urlParam;
	if(params['geocode']) {
		urlParam = 'wp='+ encodeURIComponent(params['geocode']);
	} else {
		urlParam = 'guid='+ encodeURIComponent(params['guid']);
	}

	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}
	
	var url = "http://www.geocaching.com/seek/cache_details.aspx?"+ urlParam +"&decrypt=1&log=y&numlogs="+ Geocaching.settings['logcount'];
	var ajaxId = 'cache-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var tmp, len;
			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.loadCache(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}
	
			if(-1 != reply.search('Sorry, you cannot view this cache listing until it has been published.')) {
				failure($L("Cache not found."));
				return false;
			}
			if(-1 != reply.search('has chosen to make this cache listing visible to Premium Members only')) {
				failure($L("This cache is for premium members only."));
				return false;
			}
			
			try {
				// Get GC code
				var geocode = new String(reply.match(/<span id="ctl00_uxWaypointName" class="GCCode">([^<]+)<\/span>/i)[1]).trim();
				// Clone template
				cache[geocode] = Object.clone(cacheTemplate);
				cache[geocode].geocode = geocode;
			} catch(e) {
				Geocaching.sendReport('parseCache_'+url, reply, e);
				failure($L("Error occured on cache code parsing."));
				return false;				
			}

			
			if(-1 != reply.search('<li>This cache is temporarily unavailable.')) {
				cache[geocode].disabled = true;
			} else {
				cache[geocode].disabled = false;
			}
			if(-1 != reply.search('<li>This cache has been archived,')) {
				cache[geocode].archived = true;
			} else {
				cache[geocode].archived = false;
			}
			if(-1 != reply.search('This is a Premium Member Only cache')) {
				cache[geocode].members = true;
			} else {
				cache[geocode].members = false;
			}
			if(-1 != reply.search('firstaid-yes.gif" alt="needs maintenance"')) {
				cache[geocode].needsmaint = true;
			} else {
				cache[geocode].needsmaint = false;
			}
			try {
				cache[geocode].guid = reply.match(/\?guid=([a-z0-9\-]+)"/i)[1];
				/* Cache name */
				cache[geocode].cacheid = reply.match(/(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/seek\/log\.aspx\?ID=(\d+)/i)[3];
				cache[geocode].name = reply.match(/<span id="ctl00_ContentBody_CacheName">([^<]+)<\/span>/)[1];
				cache[geocode].type = reply.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/WptTypes\/\d+.gif" ALT="([^"]+)"/i)[3]
				cache[geocode].owner = reply.match(/by <a href="[^"]+">([^<]+)<\/a>/i)[1];
				cache[geocode].size = reply.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/icons\/container\/[a-z_]+.gif" alt="Size: ([^"]+)"/i)[3]
			} catch(e) {
				Mojo.Log.error(Object.toJSON(e));
				Geocaching.sendReport('parseCache2_'+url, reply, e);
				failure($L("Error occured on cache parsing."));
				return false;
			}
			try {
				cache[geocode].latlon = reply.match(/<span id="ctl00_ContentBody_LatLon"[^>]*>([^<]*)<\/span>/i)[1];
			} catch(e) {
				try {
					cache[geocode].latlon = reply.match(/<span id="ctl00_ContentBody_LatLon"[^>]*><b>([^<]*)<\/b><\/span>/i)[1];
				} catch(e) {
					cache[geocode].latlon = "";
				}
			}
			if(-1 != reply.search('<img src="/images/stockholm/16x16/check.gif"')) {
				cache[geocode].found = true;
			} else {
				cache[geocode].found = false;
			}
			try {
				tmp = Geocaching.parseLatLon(cache[geocode].latlon);
				if(tmp != false) {
					cache[geocode].latitudeString = tmp.latitudeString;
					cache[geocode].longitudeString = tmp.longitudeString;
					cache[geocode].latitude = tmp.latitude;
					cache[geocode].longitude = tmp.longitude;
				}
			} catch(e) { }

			try {
				cache[geocode].location = reply.match(/<span id="ctl00_ContentBody_Location"[^>]*>([^<]*)/i)[1]
			} catch(e) {
				cache[geocode].location = "";
			}
			try {
				cache[geocode].hint = reply.match(/<div id="div_hint"[^>]*>(.*)<\/div>.*ctl00_ContentBody_EncryptionKey/i)[1].replace(/<br>/g, "\n").replace(/<p>/g, "\n").replace(/<\/p>/g, "");
			} catch(e) {
				cache[geocode].hint = "";
			}
			try {
				cache[geocode].terrain = reply.match(/Terrain:<\/strong>[ ]*<img src=\"(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/stars\/stars([0-9_]+)\.gif"/i)[3].replace("_", ".")
			} catch(e) {
				cache[geocode].terrain = "0";
			}
			try {
				cache[geocode].difficulty = reply.match(/Difficulty:<\/strong>[ ]*<img src=\"(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/stars\/stars([0-9_]+)\.gif"/i)[3].replace("_", ".")
			} catch(e) {
				cache[geocode].difficulty = "0";
			}
			try  {
				cache[geocode].shortdesc = reply.match(/<span id="ctl00_ContentBody_ShortDescription">(.*)<\/span>.*<span id="ctl00_ContentBody_LongDescription">/i)[1];
			} catch(e) {
				cache[geocode].shortdesc = "";
			}

			try {
				cache[geocode].description = reply.match(/<span id=\"ctl00_ContentBody_LongDescription\">(.*)<\/span>.*<div class="CacheDetailNavigationWidget">/i)[1]
			} catch(e) {
				cache[geocode].description = "";
			}

			// Event date
			try {
				cache[geocode].date = reply.match(/Event Date[ ]*:<\/strong>[ ]*([^<]+)<a href="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/my\/vcalendar/i)[3]
			} catch(e) {
				cache[geocode].date = "";
			}

			// Trackables
			cache[geocode].trackables = new Array();
			try {
				tmp = reply.match(/<a href="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/track\/details\.aspx\?guid=[a-z0-9\-]+" class="lnk">[ ]+<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/sm\/[0-9]+.gif" width="16" \/><span>[^<]+<\/span><\/a>/ig);
				if(tmp.length>0) {
					var len = tmp.length, trkTmp, trk;
					for(var z=0; z<len; z++) {
						trkTmp = tmp[z].match(/<a href="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/track\/details\.aspx\?guid=([a-z0-9\-]+)" class="lnk">[ ]+<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/sm\/([0-9]+).gif" width="16" \/><span>([^<]+)<\/span><\/a>/i);
						trk = {
							'guid': trkTmp[3],
							'img': trkTmp[6],
							'name': trkTmp[7]
						};
						cache[geocode].trackables.push(Object.clone(trk));
					}
					delete(trk); delete(trkTmp); delete(len);
				}
			} catch(e) {}

			// Attributes
			try {
				var attrs = reply.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/attributes\/[a-z\-]+\.gif" alt="[^"]+" title="[^"]+" width="30" height="30" \/>/gi)
				var attrs_len = attrs.length, attr = {}, attr_re;
				cache[geocode].attrs = new Array();
				for(var i=0; i<attrs_len; i++) {

					attr_re = attrs[i].match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/attributes\/([a-z\-]+)\.gif" alt="([^"]+)" title="[^"]+" width="30" height="30" \/>/i);
					attr = {
						'img': attr_re[3],
						'title': attr_re[4]
					};
					if(attr['title'] != 'blank') {
						cache[geocode].attrs.push(Object.clone(attr));
					}
				}
				delete(attr); delete(attrs);
			} catch(e) {
				cache[geocode].attrs = [];
			}

			// Spoiler images
			cache[geocode].spoilerImages = new Array();
			try {
				tmp = reply.match(/<a href="([^"]+)" rel="lightbox" class="lnk"><img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/stockholm\/16x16\/images.gif" \/> <span>([^<]+)<\/span><\/a>/ig);
				if(tmp.length>0) {
					var len = tmp.length, imgTmp, img;
					for(var z=0; z<len; z++) {
						imgTmp = tmp[z].match(/<a href="([^"]+)" rel="lightbox" class="lnk"><img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/stockholm\/16x16\/images.gif" \/> <span>([^<]+)<\/span><\/a>/i);
						img = {
							'name': imgTmp[4],
							'url': imgTmp[1]
						}
						cache[geocode].spoilerImages.push(Object.clone(img));
					}
					delete(img); delete(imgTmp); delete(len);
				}
			} catch(e) { }

			// Waypoints
			cache[geocode].waypoints = [];
			var wpBegin = reply.search('<span[^>]*>Additional Waypoints</span');
			var wpList, wpEnd, wpItems, wpCount, wp, waypoint;
			if(-1 != wpBegin) {
				wpList = reply.substr(wpBegin);
				wpEnd = wpList.search('</table>');
				wpList = wpList.substr(0, wpEnd);
				wpItems = wpList.split('<tr class="');
				wpCount = wpItems.length-1;
				for(var z=1; z<wpCount; z++) {
					wp = wpItems[z].split('<td');
					waypoint = {}
					try {
						waypoint['type'] = wp[3].match(/images\/wpttypes\/sm\/(.+)\.jpg/)[1]
					} catch(e) {
						waypoint['type'] = 'waypoint';
					}
					try {
						waypoint['prefix'] = new String(wp[4].match(/>([^<]*)<\/span>/)[1]).trim();
					} catch(e) {
						waypoint['prefix'] = '';
					}
					try {
						waypoint['lookup'] = new String(wp[5].match(/>([^<]*)<\/td>/)[1]).trim();
					} catch(e) {
						waypoint['lookup'] = '';
					}
					try {
						waypoint['name'] = new String(wp[6].match(/>([^<]*)<\/a>/)[1]).trim();
					} catch(e) {
						waypoint['name'] = '';
					}
					try {
						waypoint['latlon'] = new String(wp[7].match(/>([^<]*)<\/td>/)[1]).replace(/&nbsp;/g, ' ').trim();
						tmp = Geocaching.parseLatLon(waypoint['latlon']);
						if(tmp != false) {
							waypoint['latitudeString'] = tmp.latitudeString;
							waypoint['longitudeString'] = tmp.longitudeString;
							waypoint['latitude'] = tmp.latitude;
							waypoint['longitude'] = tmp.longitude;
						}
					} catch(e) {
						Mojo.Log.error(Object.toJSON(e));
						waypoint['latlon'] = '';
					}
					// On next row is Note
					z++;
					wp = wpItems[z].split('<td');
					try {
						waypoint['note'] = wp[3].match(/colspan="6">(.*)<\/td>/)[1]
					} catch(e) {
						waypoint['note'] = '';
					}
					// Add only present waypoint
					if(waypoint['prefix'] != '') {
						cache[geocode].waypoints.push(Object.clone(waypoint));
					}
				}
			}

			// Cache logs
			cache[geocode].logs = [];
			wpBegin = reply.search('<table class="LogsTable Table">');
			var clog;
			if(-1 != wpBegin) {
				wpList = reply.substr(wpBegin);
				// wpEnd = wpList.search('</table>');
				wpEnd = wpList.search('<time');
				wpList = wpList.substr(0, wpEnd);
				wpItems = wpList.split('<tr><td class');
				wpCount = wpItems.length;
				for(var z=1; z<wpCount; z++) {
					wp = wpItems[z];

					clog = {};
					try {
						clog['author'] = wp.match(/id=["']\d+['"]>([^<]*)<\/a>/i)[1]
					} catch(e) {
						clog['author'] = '';
					}

					try {
						tmp = wp.match(/&nbsp;(.*) by <a/i)[1];
						// Add current year
						if(!tmp.match(/[0-9]{4}$/)) {
							tmp += ", "+ new Date().getFullYear();
						}
						clog['date'] = Mojo.Format.formatDate(new Date(tmp), {'date':'medium', 'time':''});
					} catch(e) {
						clog['date'] = '';
					}

					try {
						tmp = wp.match(/(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/icons\/([^\.]+)\.gif/)[3];
					} catch(e) {
						tmp = 'note';
					}

					switch(tmp)
					{
						case 'icon_smile':
							clog['icon'] = 'found';
						break;
						case 'icon_sad':
							clog['icon'] = 'notfound';
						break;
						case 'icon_greenlight':
							clog['icon'] = 'published';
						break;
						case 'icon_needsmaint':
							clog['icon'] = 'needsmaint';
						break;
						case 'icon_maint':
							clog['icon'] = 'maint';
						break;
						case 'icon_disabled':
							clog['icon'] = 'disabled';
						break;
						case 'icon_enabled':
							clog['icon'] = 'enabled';
						break;
						case 'coord_update':
							clog['icon'] = 'coords';
						break;
						case 'big_smile':
							clog['icon'] = 'reviewernote';
						break;
						case 'traffic_cone':
							clog['icon'] = 'archive';
						break;
						case 'icon_note':
						default:
							clog['icon'] = 'note';
						break;
					}

					try {
						tmp = wp.match(/\((\d+) found\)<br[ ]*\/>(.*)<br[ ]*\/><br[ ]*\/><small>/i)
						clog['founds'] = tmp[1];
						clog['body'] = tmp[2].replace(/^<br[ ]*\/>/, "").replace(/<p>/g, "<br />").replace(/<\/p>/g, "");
					} catch(e) {
						clog['founds'] = '-';
						clog['body'] = '';
					}

					cache[geocode].logs.push(Object.clone(clog));
				}
			}
			success(geocode);
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching cache."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting cache failed, retrying ..."}, "", "cache");
				params['retry']++;
				this.loadCache(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
}

GeocachingCom.prototype.loadTrackable = function(params, success, failure)
{
	var urlParam;
	if(params['tbcode']) {
		urlParam = 'tracker='+ encodeURIComponent(params['tbcode']);
	} else
	if(params['id']) {
		urlParam = 'id='+ encodeURIComponent(params['id']);
	} else {
		urlParam = 'guid='+ encodeURIComponent(params['guid']);
	}

	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}
	
	var url = "http://www.geocaching.com/track/details.aspx?"+ urlParam;
	var ajaxId = 'trackable-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var tmp, len;
			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.loadTrackable(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}
			try {
				// Get TB code
				var tbcode = reply.match(/<meta name="og:url" content="http:\/\/coord.info\/(TB.*)" property="og:url" \/>/i)[1];
				// Clone template
				trackable[tbcode] = Object.clone(trackableTemplate);
				trackable[tbcode].tbcode = tbcode;
			} catch(e) {
				Geocaching.sendReport('parseTrackable_'+url, reply, e);
				Mojo.Log.error(Object.toJSON(e));
				failure($L("Error occured on parsing trackable."));
				return false;
			}

			// TB guid
			try {
				trackable[tbcode].guid = reply.match(/log\.aspx\?wid=([a-z0-9\-]+)"/i)[1]
			} catch(e) {
				trackable[tbcode].guid = '';
			}
			
			// TB name
			trackable[tbcode].name = reply.match(/<span id="ctl00_ContentBody_lbHeading">([^<]+)<\/span>/i)[1]

			// TB type
			try {
				trackable[tbcode].type = reply.match(/<img id="ctl00_ContentBody_BugTypeImage" class="TravelBugHeaderIcon" src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/([^\.]+)\.gif"/i)[3]
			} catch(e) {
				trackable[tbcode].type = '21';
			}

			// TB Released
			try {
				trackable[tbcode].released = new String(reply.match(/<span id="ctl00_ContentBody_BugDetails_BugReleaseDate">([^<]+)<\/span>/i)[1]).trim()
			} catch(e) {
				trackable[tbcode].released = 'N/A';
			}

			// TB Origin
			try {
				trackable[tbcode].origin = new String(reply.match(/<span id="ctl00_ContentBody_BugDetails_BugOrigin">([^<]+)<\/span>/i)[1]).trim()
			} catch(e) {
				trackable[tbcode].origin = 'N/A';
			}
			
			// TB Image
			try {
				trackable[tbcode].image = new String(reply.match(/<img id="ctl00_ContentBody_BugDetails_BugImage" class="TrackableItemDetailsImage" src="([^"]+)"/i)[1]).trim()
			} catch(e) {
				trackable[tbcode].image = '';
			}
			
			// TB Owner
			try {
				trackable[tbcode].owner = new String(reply.match(/<a id="ctl00_ContentBody_BugDetails_BugOwner"[^>]*>([^<]+)<\/a>/i)[1]).trim()
			} catch(e) {
				trackable[tbcode].owner = '';
			}
			
			// TB traveled
			try {
				trackable[tbcode].traveled = new String(reply.match(/Tracking History \(([0-9\.km]+)/i)[1]).trim()
			} catch(e) {
				trackable[tbcode].traveled = $L("None");
			}
			
			// TB ID
			try {
				trackable[tbcode].travelid = new String(reply.match(/\?ID=([0-9]+)"/)[1]).trim()
			} catch(e) {
				trackable[tbcode].travelid = '';
			}

			// TB Goal
			try {
				trackable[tbcode].goal = reply.match(/Current GOAL[ ]*<\/h3>[ ]*<p class="NoSpacing">(.*)<\/p>[ ]*<h3>[ ]*About this item/i)[1]
			} catch(e) {
				trackable[tbcode].goal = "";
			}

			// TB About item
			try {
				trackable[tbcode].about = reply.match(/Current GOAL[ ]*<\/h3>.*<p class="NoSpacing">(.*)<\/p>.*<div id="ctl00_ContentBody_BugDetails_uxAbuseReport">/i)[1]
			} catch(e) {
				trackable[tbcode].about = "";
			}
			
			// TB Location
			try {
				trackable[tbcode].location = reply.match(/<a id="ctl00_ContentBody_BugDetails_BugLocation" href="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/profile\/[^"]*">In the hands of ([^<]+)\.<\/a>/i)[3]
			} catch(e) {
				trackable[tbcode].location = "";
			}

			// Location is cache
			if(trackable[tbcode].location == "") {
				try {
					tmp = reply.match(/<a id="ctl00_ContentBody_BugDetails_BugLocation" title="[^"]*" href="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/seek\/cache_details.aspx\?guid=([^"]*)">In ([^<]+)<\/a>/i);
					trackable[tbcode].locationGuid = tmp[3];
					trackable[tbcode].location = tmp[4];
					trackable[tbcode].locationType = 'cache';
				} catch(e) {}
				
				// Somewhere else
				if(trackable[tbcode].location == "") {
					try {
						trackable[tbcode].locationType = 'none';
						trackable[tbcode].location = reply.match(/<a id="ctl00_ContentBody_BugDetails_BugLocation">([^<]+)<\/a>/i)[1];
					} catch(e) {}
				}
			}

			// TB Logs
			trackable[tbcode].logs = [];
			wpBegin = reply.search('<table class="TrackableItemLogTable Table">');
			var clog;
			if(-1 != wpBegin) {
				wpList = reply.substr(wpBegin);
				// wpEnd = wpList.search('</table>');
				wpEnd = wpList.search('<ul class="pager">');
				wpList = wpList.substr(0, wpEnd);
				wpItems = wpList.split('<tr class="Data');
				wpCount = wpItems.length-1;
				for(var z=1; z<wpCount; z++) {
					wp = wpItems[z].split('<td>');

					clog = {};
					try {
						clog['author'] = wp[2].match(/profile\/\?guid=[^"]+">([^<]*)<\/a>/i)[1]
					} catch(e) {
						Mojo.Log.error(Object.toJSON(e));
						clog['author'] = '';
					}

					try {
						clog['body'] = '<small>'+ new String(wp[2].match(/^(.*)<\/td>/i)[1]).trim().stripTags() + '</small>';
					} catch(e) {
						clog['body'] = '';
					}

					try {
						tmp = wp[1].match(/&nbsp;([0-9\/]*)/i)[1];
						clog['date'] = Mojo.Format.formatDate(new Date(tmp), {'date':'medium', 'time':''});
					} catch(e) {
						clog['date'] = '';
					}

					try {
						tmp = wp[1].match(/\/images\/icons\/([^\.]+)\.gif/)[1];
					} catch(e) {
						tmp = 'note';
					}

					switch(tmp)
					{
						case 'picked_up':
							clog['icon'] = 'picked_up';
						break;
						case 'dropped_off':
							clog['icon'] = 'dropped_off';
						break;
						case 'icon_discovered':
							clog['icon'] = 'discovered';
						break;
						case 'icon_visited':
							clog['icon'] = 'visited';
						break;
						case 'icon_note':
						default:
							clog['icon'] = 'note';
						break;
					}

					z++;
					wp = wpItems[z];
					try {
						clog['body'] += "<br /><br />\n" + new String(wp.match(/<td colspan="4">(.*)<\/td>/i)[1]).trim()
					} catch(e) {
					}

					trackable[tbcode].logs.push(Object.clone(clog));
				}
			} // End of logs

			success(tbcode);
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching trackable."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting trackable failed, retrying ..."}, "", "trackable");
				params['retry']++;
				this.loadTrackable(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

GeocachingCom.prototype.parseTrackablesSearch = function(url, reply)
{
	var viewstate = new Array();
	var viewstate0, viewstate1, viewstate2, viewstate3;
	try {
		viewstate0 = reply.match(/id="__VIEWSTATE" value="([^"]+)"/)[1]
		viewstate.push(viewstate0);
	} catch(e) { }

	try {
		viewstate1 = reply.match(/id="__VIEWSTATE1" value="([^"]+)"/)[1]
		viewstate.push(viewstate1);
	} catch(e) { }
	
	try {
		viewstate2 = reply.match(/id="__VIEWSTATE2" value="([^"]+)"/)[1]
		viewstate.push(viewstate2);
	} catch(e) { }

	try {
		viewstate3 = reply.match(/id="__VIEWSTATE3" value="([^"]+)"/)[1]
		viewstate.push(viewstate3);
	} catch(e) { }

	var tmp, len;

	var startPos = reply.indexOf('<table class="Table"');
	if(startPos == -1)
		return false;
	
	var r = reply.substr(startPos); // Cut on <table

	startPos = r.indexOf('>');
	var endPos = r.indexOf('</table>');
	if(startPos == -1 || endPos == -1)
		return false;

	r = r.substr(startPos+1, endPos-startPos+1); // Cut between <table> and </table>

	var rows = r.split("<tr");
	var rows_count = rows.length;
	var list = new Array();
	var listRow = {};
	var row, tmp;

	for(var z=1; z<rows_count; z++) { try {
		row = rows[z];
		listRow = {};

		// Trackable name
		try {
			tmp = row.match(/<a href="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/track\/details\.aspx\?id=([0-9]+)">([^<]+)<\/a>/i);
			listRow['id'] = tmp[3];
			listRow['name'] = tmp[4];
		} catch(e) {
			continue;
		}

		// Trackable type
		try {
			listRow['img'] = row.match(/<img src="(http:\/\/([\-0-9\.a-z\/]*)?www\.geocaching\.com)?\/images\/wpttypes\/sm\/([^\.]+)\.gif/i)[3]
		} catch(e) {
			listRow['img'] = '21';
		}

		list.push({
			'guid': listRow['id'],
			'name': listRow['name'],
			'img': listRow['img']
		});
	} catch(e) {
		Mojo.Log.error(Object.toJSON(e));
		if(Geocaching.sendReport('parseTrackables_'+url, reply, e)) {
			break;
		}
	}; }
	var trackables = list.length;
	if(trackables == 0) {
		return false;
	}
	
	var searchResult = {
		'url': url,
		'viewstate': viewstate,
		'trackablesList': list,
		'trackableId': 'id',
		'nextPage': (trackables < 20 ? false : true)
//		'offset': 0,
//		'limit': trackables
	}
	return searchResult;
};

GeocachingCom.prototype.yourTrackables = function(params, success, failure)
{
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}
	
	var url = "http://www.geocaching.com/track/search.aspx?o=1&uid="+ Geocaching.login['uid'];
	var ajaxId = 'yourtrackables-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");
			
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.yourTrackables(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}

			var list = this.parseTrackablesSearch(url, reply);
			if(list == false) {
				failure($L("No more trackables found."));
			} else {
				success(list);
			}
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching trackable list."));
		},
		'onException': function(r){
			failure($L("Error occured on parsing trackable list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting trackable list failed, retrying ..."}, "", "trackable");
				params['retry']++;
				this.yourTrackables(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

GeocachingCom.prototype.searchTrackables = function(params, success, failure)
{
	var keyword = params['keyword'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}
	
	var url = "http://www.geocaching.com/track/search.aspx?k="+ encodeURIComponent(keyword);
	var ajaxId = 'keyword-'+ keyword +'-'+ Math.round(new Date().getTime());

	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");
			
			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.searchTrackables(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}

			var list = this.parseTrackablesSearch(url, reply);
			if(list == false) {
				failure($L("No more trackables found."));
			} else {
				success(list);
			}
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching trackable list."));
		},
		'onException': function(r){
			failure($L("Error occured on parsing trackable list."));
		}
	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting trackable list failed, retrying ..."}, "", "trackable");
				params['retry']++;
				this.searchTrackables(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

GeocachingCom.prototype.searchTrackablesByUrlNextPage = function(params, success, failure)
{
	var url = params['url'];
	var viewstate = params['viewstate'];
	var viewstate_len = viewstate.length;
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	var parameters = {
		'__VIEWSTATE' : viewstate[0],
		'__EVENTTARGET': 'ctl00$ContentBody$ResultsPager$ctl08',
		'__EVENTARGUMENT': ''
	}

	if(viewstate_len > 1) {
			for(var i=1; i<viewstate_len; i++) {
				parameters['__VIEWSTATE'+i] = viewstate[i]
			}
			parameters['__VIEWSTATEFIELDCOUNT'] = viewstate_len;
	}

	var ajaxId = 'nextpage-'+ viewstate[0].substr(0,16) +'-'+ Math.round(new Date().getTime());
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'post',
		'parameters': parameters,
		'contentType': 'application/x-www-form-urlencoded',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");

			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.searchTrackablesByUrlNextPage(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}

			var list = this.parseTrackablesSearch(url, reply);
			if(list == false) {
				failure($L("No more trackables found."));
			} else {
				success(list);
			}
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching trackable list."));
		},
		'onException': function(r){
			failure($L("Error occured on parsing trackable list."));
		}

	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting trackable list failed, retrying ..."}, "", "trackable");
				params['retry']++;
				this.searchTrackablesByUrlNextPage(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

/**
 * Load parameters from "Post a New Log" page
 * 
 * @param {Object} params Request parameters
 * @param {Function} success Function to lauch after success
 * @param {Function} failure Function to lauch after any failure
 */
GeocachingCom.prototype.postLogLoad = function(params, success, failure)
{
	var url = 'http://www.geocaching.com/seek/log.aspx?ID='+ params['cacheid'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	var ajaxId = 'postlog-get-'+ params['cacheid'] +'-'+ Math.round(new Date().getTime());
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");

			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.postLogLoad(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}

			var logParams = {
				'viewstate': '',
				'logTypes': [],
				'trackables': []
			};
			var i;

			// Log types
			var logTypesBegin = reply.search('ctl00_ContentBody_LogBookPanel1_ddLogType');
			if (-1 != logTypesBegin) {
	  		var logTypesSelect = reply.substr(logTypesBegin);
				var logTypesEnd = logTypesSelect.search('</select>');
				logTypesSelect = logTypesSelect.substr(0, logTypesEnd);
				var logTypes = logTypesSelect.split('<option');
				var logTypesCount = logTypes.length;
				var _logType;
				logParams['logTypes'] = new Array();
				for(i=1; i<logTypesCount; i++) {
					_logType = logTypes[i].match(/value="([^"]*)"/i)[1]
					if (_logType > 0) {
		  			logParams['logTypes'].push(_logType);
		  		}
				}
				delete(logTypes); delete(logTypesSelect);
			}
			
			// Viewstate
			logParams['viewstate'] = reply.match(/id="__VIEWSTATE"\s+value="(.+?)"/)[1]

			// Trackables
			var trackablesBegin = reply.search('<table id="tblTravelBugs" class="LogTrackablesTable Table Spacing">');
			if (-1 != trackablesBegin) {
	  		var trackablesTable = reply.substr(trackablesBegin);
				var trackablesEnd = trackablesTable.search('</table>');
				trackablesTable = trackablesTable.substr(0, trackablesEnd);
				var trackables = trackablesTable.split('<tr id="');
				var trackablesCount = trackables.length;
				var _trackable, tmp;
				logParams['trackables'] = new Array();
				for(i=1; i<trackablesCount; i++) {
					try {
						_trackable = {};
						tmp = trackables[i].split('<td');
						_trackable['num'] = i;
						_trackable['choice'] = '';
						_trackable['name'] = tmp[2].match(/^>(.*)<\/td>/i)[1];
						_trackable['msid'] = trackables[i].match(/<select name="([^"]*)"/i)[1];
						_trackable['tracker'] = trackables[i].match(/\/track\/details\.aspx\?tracker=([^"]*)/i)[1];
						_trackable['id'] = trackables[i].match(/<option value="([0-9]+)">/i)[1];
		  			logParams['trackables'].push(_trackable);
					} catch(e) {
						Mojo.Log.error(Object.toJSON(e));
					}
				}
				delete(trackables); delete(trackablesTable); delete(tmp);
			}

			success(logParams);

		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching post log page."));
		},
		'onException': function(r){
			failure($L("Error occured on fetching post log page."));
		}

	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting post log page failed, retrying ..."}, "", "postlog");
				params['retry']++;
				this.postLogLoad(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

GeocachingCom.prototype.postLogSubmit = function(params, success, failure){
	var url = 'http://www.geocaching.com/seek/log.aspx?ID='+ params['cacheid'];
	var now = new Date();
	var nowMonth = now.getMonth() +1;
	var nowDay = now.getDate();
	var nowYear = now.getFullYear();
	var nowLogged = nowMonth +'/'+ nowDay +'/' + nowYear;
	
	var parameters = {
		'__EVENTTARGET': '',
		'__EVENTARGUMENT': '',
		'__LASTFOCUS': '',
		'__VIEWSTATE': params['viewstate'],
		'ctl00$ContentBody$LogBookPanel1$ddLogType': params['logType'],
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged': nowLogged,
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged$Month': nowMonth,
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged$Day': nowDay,
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged$Year': nowYear,
		'ctl00$ContentBody$LogBookPanel1$uxLogInfo': params['body'],
		'ctl00$ContentBody$LogBookPanel1$uxTrackables$hdnSelectedActions': '',
		'ctl00$ContentBody$LogBookPanel1$uxTrackables$hdnCurrentFilter': '',
		'ctl00$ContentBody$uxVistOtherListingGC': '',
		'ctl00$ContentBody$LogBookPanel1$LogButton': 'Submit Log Entry'
	}

	var z, trackablesCount = params['trackables'].length, _trName, _trValue;
	for(z=0; z<trackablesCount; z++) {
		_trName = params['trackables'][z]['msid'];
		_trValue = params['trackables'][z]['choice'];
		if(_trValue != '') {
			_trValue = params['trackables'][z]['id'] +'_'+ _trValue;
			parameters[_trName] = _trValue;
			parameters['ctl00$ContentBody$LogBookPanel1$uxTrackables$hdnSelectedActions'] += _trValue +',';
		}
	}

	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}
	
	var ajaxId = 'postlog-post-'+ params['cacheid'] +'-'+ Math.round(new Date().getTime());
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'post',
		'parameters': parameters,
		'contentType': 'application/x-www-form-urlencoded',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");
			
			if(-1 != reply.search('An Error Has Occurred')) {
				failure($L("Error occured in log posting."));
				return false;
			}

			success();			
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured in log posting."));
		},
		'onException': function(r){
			failure($L("Error occured in log posting."));
		}

	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Sending log failed, retrying ..."}, "", "postlog");
				params['retry']++;
				this.postLogSubmit(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

/**
 * Load parameters from "Post a New Log" page of Trackable
 * 
 * @param {Object} params Request parameters
 * @param {Function} success Function to lauch after success
 * @param {Function} failure Function to lauch after any failure
 */
GeocachingCom.prototype.postLogTrackableLoad = function(params, success, failure)
{
	var url = 'https://www.geocaching.com/track/log.aspx?wid='+ params['guid'];
	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}

	Mojo.Log.info(url);

	var ajaxId = 'postlogt-get-'+ params['guid'] +'-'+ Math.round(new Date().getTime());
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'get',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");

			if(!this.checkLogin(reply)) {
				this.doLogin(
					Geocaching.login['username'],
					Geocaching.login['password'], 
					function() {
						this.postLogTrackableLoad(params, success, failure);
					}.bind(this),
					failure
				);
				return false;
			}

			var logParams = {
				'viewstate': '',
				'logTypes': []
			};
			var i;

			// Log types
			var logTypesBegin = reply.search('ctl00_ContentBody_LogBookPanel1_ddLogType');
			if (-1 != logTypesBegin) {
	  		var logTypesSelect = reply.substr(logTypesBegin);
				var logTypesEnd = logTypesSelect.search('</select>');
				logTypesSelect = logTypesSelect.substr(0, logTypesEnd);
				var logTypes = logTypesSelect.split('<option');
				var logTypesCount = logTypes.length;
				var _logType;
				logParams['logTypes'] = new Array();
				for(i=1; i<logTypesCount; i++) {
					_logType = logTypes[i].match(/value="([^"]*)"/i)[1]
					if (_logType > 0) {
		  			logParams['logTypes'].push(_logType);
		  		}
				}
				delete(logTypes); delete(logTypesSelect);
			}
			
			// Viewstate
			logParams['viewstate'] = reply.match(/id="__VIEWSTATE"\s+value="(.+?)"/)[1]

			success(logParams);
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured on fetching post log page."));
		},
		'onException': function(r){
			failure($L("Error occured on fetching post log page."));
		}

	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Getting post log page failed, retrying ..."}, "", "postlog");
				params['retry']++;
				this.postLogTrackableLoad(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};

GeocachingCom.prototype.postLogTrackablesSubmit = function(params, success, failure){
	var url = 'http://www.geocaching.com/track/log.aspx?wid='+ params['guid'];
	var now = new Date();
	var nowMonth = now.getMonth() +1;
	var nowDay = now.getDate();
	var nowYear = now.getFullYear();
	var nowLogged = nowMonth +'/'+ nowDay +'/' + nowYear;
	
	var parameters = {
		'__EVENTTARGET': '',
		'__EVENTARGUMENT': '',
		'__LASTFOCUS': '',
		'__VIEWSTATE': params['viewstate'],
		'ctl00$ContentBody$LogBookPanel1$ddLogType': params['logType'],
		'ctl00$ContentBody$LogBookPanel1$tbCode': params['trackingCode'],
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged': nowLogged,
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged$Month': nowMonth,
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged$Day': nowDay,
		'ctl00$ContentBody$LogBookPanel1$DateTimeLogged$Year': nowYear,
		'ctl00$ContentBody$LogBookPanel1$uxLogInfo': params['body'],
		'ctl00$ContentBody$uxVistOtherListingGC': '',
		'ctl00$ContentBody$LogBookPanel1$LogButton': 'Submit Log Entry'
	}

	var timeout = Geocaching.settings['firstTimeout'];
	if(typeof(params['retry']) != 'undefined' && params['retry']>1) {
		var timeout = Geocaching.settings['secondTimeout'];
	} else {
		params['retry'] = 1;
	}
	
	var ajaxId = 'postlog-post-'+ params['cacheid'] +'-'+ Math.round(new Date().getTime());
	Geocaching.ajaxRequests[ajaxId] = new Ajax.Request(url, {
		'method': 'post',
		'parameters': parameters,
		'contentType': 'application/x-www-form-urlencoded',
		'onSuccess': function(r){
			Geocaching.lastAjaxId = null;
			delete(Geocaching.ajaxRequests[ajaxId]);

			var reply = r.responseText.replace(/\n/g, " ").replace(/\r/g, "").replace(/\t/g," ");
			
			if(-1 != reply.search('An Error Has Occurred')) {
				failure($L("Error occured in log posting."));
				return false;
			}
			
			if(-1 != reply.search('Sorry. The tracking number does not match for this trackable.')) {
				failure($L("The tracking number does not match for this trackable."));
				return false;
			}

			success();			
		}.bind(this),
		'onFailure': function(r){
			failure($L("Error occured in log posting."));
		},
		'onException': function(r){
			failure($L("Error occured in log posting."));
		}

	});
	Geocaching.lastAjaxId = ajaxId;

	window.setTimeout(function(ajaxId, params, success, failure) {
		if(Ajax.activeRequestCount > 0 && ajaxId == Geocaching.lastAjaxId) {
			Geocaching.ajaxRequests[ajaxId].abort();
			delete(Geocaching.ajaxRequests[ajaxId]);

			if(params['retry']>1) {
				failure($L("Operation timeout"));
			} else {
				Mojo.Controller.getAppController().showBanner({'messageText': "Sending log failed, retrying ..."}, "", "postlog");
				params['retry']++;
				this.postLogSubmit(params, success, failure);
			}
		}
	}.bind(this), timeout*1000, ajaxId, params, success, failure);
};
